//md2.h
#ifndef _MD2_H
#define _MD2_H
#pragma once

#include <stdio.h>
#include <d3dx9.h>

struct MD2Header
{
	int id;			
	int version;		
	int skinWidth;		
	int skinHeight;		
	int frameSize;		
	int numSkins;		
	int numVertices;	
	int numTexCoords;
	int numTris;	
	int numGLCmds;	
	int numFrames;		
	int offsetSkins;	
	int offsetTexCoords;
	int offsetTris;
	int offsetFrames;
	int offsetGLCmds;
	int offsetEnd;	
};

struct Md2Skins
{
	char textureName[64];
};


struct Md2TextureCoords
{
	short u, v;
};

//ﰢ ؽ, ؽ ε 
struct Md2TriIndex
{
	short vertexIndex[3];
	short textureIndex[3];
};


//Md2Vertex, Md2Frames ̷ƮX  ϱ   Ÿ
struct Md2Vertex
{
	float vertex[3];
	float normal[3];
};

struct Md2Frames
{
	char name[16];   // ̸
	Md2Vertex* pData;
};

//Md2DataVertex, Md2DataFrame md2  б  ӽ÷ ϱ  ü̴.
struct TempMd2DataVertex
{
	byte vertex[3]; 
	byte normalIndex; 
};
struct TempMd2DataFrame
{
	float scale[3];
	float translate[3];
	char name[16];
	TempMd2DataVertex data[1];
};


struct aniKeyFrame
{
	int start;
	int end;
	char szName[16];
};
struct aniKey
{
	int numKeys;
	aniKeyFrame *pKey;
};


//ؽ ü Ÿ 
struct MyVertex
{
    FLOAT x, y, z;	// D3DFVF_XYZ
    FLOAT tu, tv;   // D3DFVF_TEX1
};
#define  MYVERETX_FVF (D3DFVF_XYZ | D3DFVF_TEX1)


class CMd2
{
public:
	CMd2();
	~CMd2();

	bool Load(char* szFileName, char* szTextureName, LPDIRECT3DDEVICE9 pD3DDevice);
	void Release();
	
	void Render(LPDIRECT3DDEVICE9 pD3DDevice);

	void SetAnimationKey(int iAnimationKey = -1);
	void Update(float fTime);

private:
	bool ReadHeader(FILE* fp);
	bool ReadData(FILE* fp);

	// ִŰ  зѴ.
	void BuildAnimationKey();
	
	void MakeDX(LPDIRECT3DDEVICE9 pD3DDevice);
	void MakeDXVertices(int iFrame);


private:
	MD2Header	    m_md2Header;
	Md2Skins*	    m_pSkins;
	Md2TextureCoords* m_pTextureCoords;	
	Md2TriIndex*    m_pTriIndex;  
	Md2Frames*		m_pFrames;

	aniKey			m_aniKey;   
	int				m_iAnimationKey;

	IDirect3DVertexBuffer9* m_vb;
	IDirect3DTexture9*	    m_pTexture;
	int				m_iCurFrame;
	float			m_lastTime;
};

#endif